<html>
<head>
<title>OgreDepthBuffer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreDepthBuffer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreDepthBuffer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __DepthBuffer_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __DepthBuffer_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>Ogre
<a name="l00034"></a>00034 {
<a name="l00081"></a><a class="code" href="classOgre_1_1DepthBuffer.html">00081</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1DepthBuffer.html" title="An abstract class that contains a depth/stencil buffer.">DepthBuffer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RenderSysAlloc</a>
<a name="l00082"></a>00082     {
<a name="l00083"></a>00083     <span class="keyword">public</span>:
<a name="l00084"></a><a class="code" href="group__RenderSystem.html#ga9854c57374adef41216bae68544a5b7e">00084</a>         <span class="keyword">enum</span> <a class="code" href="group__RenderSystem.html#ga9854c57374adef41216bae68544a5b7e">PoolId</a>
<a name="l00085"></a>00085         {
<a name="l00086"></a><a class="code" href="group__RenderSystem.html#gga9854c57374adef41216bae68544a5b7ea569228ed0fdd8d428a5117026b6d010e">00086</a>             POOL_NO_DEPTH       = 0,
<a name="l00087"></a><a class="code" href="group__RenderSystem.html#gga9854c57374adef41216bae68544a5b7ea2d5409ddce167e1db415f09ee2160440">00087</a>             POOL_MANUAL_USAGE   = 0,
<a name="l00088"></a><a class="code" href="group__RenderSystem.html#gga9854c57374adef41216bae68544a5b7ea00a687046bfe7a9ebd7f34256d3fbcca">00088</a>             POOL_DEFAULT        = 1
<a name="l00089"></a>00089         };
<a name="l00090"></a>00090 
<a name="l00091"></a>00091         <a class="code" href="classOgre_1_1DepthBuffer.html" title="An abstract class that contains a depth/stencil buffer.">DepthBuffer</a>( <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> poolId, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> bitDepth, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> width, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> height,
<a name="l00092"></a>00092                      <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> fsaa, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;fsaaHint, <span class="keywordtype">bool</span> manual );
<a name="l00093"></a>00093         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1DepthBuffer.html" title="An abstract class that contains a depth/stencil buffer.">DepthBuffer</a>();
<a name="l00094"></a>00094 
<a name="l00095"></a>00095         <span class="comment">//Sets the pool id in which this DepthBuffer lives</span>
<a name="l00096"></a>00096         <span class="comment">//Note this will detach any render target from this depth buffer</span>
<a name="l00097"></a>00097         <span class="keywordtype">void</span> _setPoolId( <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> poolId );
<a name="l00098"></a>00098 
<a name="l00099"></a>00099         <span class="comment">//Gets the pool id in which this DepthBuffer lives</span>
<a name="l00100"></a>00100         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> getPoolId() <span class="keyword">const</span>;
<a name="l00101"></a>00101         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> getBitDepth() <span class="keyword">const</span>;
<a name="l00102"></a>00102         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> getWidth() <span class="keyword">const</span>;
<a name="l00103"></a>00103         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> getHeight() <span class="keyword">const</span>;
<a name="l00104"></a>00104         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> getFsaa() <span class="keyword">const</span>;
<a name="l00105"></a>00105         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getFsaaHint() <span class="keyword">const</span>;
<a name="l00106"></a>00106 
<a name="l00107"></a>00107         <span class="comment">//Manual DepthBuffers are cleared in RenderSystem&#39;s destructor. Non-manual ones are released</span>
<a name="l00108"></a>00108         <span class="comment">//with it&#39;s render target (aka, a backbuffer or similar)</span>
<a name="l00109"></a>00109         <span class="keywordtype">bool</span> isManual() <span class="keyword">const</span>;
<a name="l00110"></a>00110 
<a name="l00120"></a>00120         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isCompatible( <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *renderTarget ) <span class="keyword">const</span>;
<a name="l00121"></a>00121 
<a name="l00129"></a>00129         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyRenderTargetAttached( <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *renderTarget );
<a name="l00130"></a>00130 
<a name="l00136"></a>00136         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyRenderTargetDetached( <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *renderTarget );
<a name="l00137"></a>00137 
<a name="l00138"></a>00138     <span class="keyword">protected</span>:
<a name="l00139"></a><a class="code" href="group__RenderSystem.html#ga842c0f22b9bdbe661583f5459799b1db">00139</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html">set&lt;RenderTarget*&gt;::type</a> <a class="code" href="group__RenderSystem.html#ga842c0f22b9bdbe661583f5459799b1db">RenderTargetSet</a>;
<a name="l00140"></a>00140 
<a name="l00141"></a><a class="code" href="group__RenderSystem.html#ga8898edcd32480833756db34086b73e95">00141</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>                      <a class="code" href="group__RenderSystem.html#ga8898edcd32480833756db34086b73e95">mPoolId</a>;
<a name="l00142"></a><a class="code" href="group__RenderSystem.html#gac0fb796a44c5f0abfa197d4185a85227">00142</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>                      <a class="code" href="group__RenderSystem.html#gac0fb796a44c5f0abfa197d4185a85227">mBitDepth</a>;
<a name="l00143"></a><a class="code" href="group__RenderSystem.html#ga06e7b623df9b2b5827c51bc8756f7ef4">00143</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>                      <a class="code" href="group__RenderSystem.html#ga06e7b623df9b2b5827c51bc8756f7ef4">mWidth</a>;
<a name="l00144"></a><a class="code" href="group__RenderSystem.html#ga1e7ca8b8f4774aa786987b9454be86d3">00144</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>                      <a class="code" href="group__RenderSystem.html#ga1e7ca8b8f4774aa786987b9454be86d3">mHeight</a>;
<a name="l00145"></a><a class="code" href="group__RenderSystem.html#ga18ea722feff9985a01e57a7f9f0f9052">00145</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>                      <a class="code" href="group__RenderSystem.html#ga18ea722feff9985a01e57a7f9f0f9052">mFsaa</a>;
<a name="l00146"></a><a class="code" href="group__RenderSystem.html#ga97b950482c8f1ab2f6ba47bb4f77b2e2">00146</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>                      <a class="code" href="group__RenderSystem.html#ga97b950482c8f1ab2f6ba47bb4f77b2e2">mFsaaHint</a>;
<a name="l00147"></a>00147 
<a name="l00148"></a><a class="code" href="group__RenderSystem.html#ga48a92115245b988be0be1a254c2bc9af">00148</a>         <span class="keywordtype">bool</span>                        <a class="code" href="group__RenderSystem.html#ga48a92115245b988be0be1a254c2bc9af">mManual</a>; <span class="comment">//We don&#39;t Release manual surfaces on destruction</span>
<a name="l00149"></a><a class="code" href="group__RenderSystem.html#ga303a8362b22c324be2e57c780b870b3a">00149</a>         <a class="code" href="group__RenderSystem.html#ga842c0f22b9bdbe661583f5459799b1db">RenderTargetSet</a>             <a class="code" href="group__RenderSystem.html#ga303a8362b22c324be2e57c780b870b3a">mAttachedRenderTargets</a>;
<a name="l00150"></a>00150 
<a name="l00151"></a>00151         <span class="keywordtype">void</span> detachFromAllRenderTargets();
<a name="l00152"></a>00152     };
<a name="l00153"></a>00153 }
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
